﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.ServiceModel;

namespace ServerMain
{
    //服務契約定義了可以遠程調用的對象和方法
    //定義服務契約
    [XmlSerializerFormat]//定義序列化的方式
    [ServiceContract(SessionMode = SessionMode.Allowed)]//SessionMode = SessionMode.Allowed：設置此屬性意味著可以使用會話Binding
    public interface IActionMain
    {
        //定義操作契約
        [DataContractFormat]//定義序列化的方式
        [OperationContract]
        string GetName(string pInc);

        [FaultContract(typeof(ErroInfo.Erro))]//如果有異常就返回下面定義的數據契約的結構數據
        [FaultContract(typeof(DivideByZeroException))]
        [OperationContract]
        DataCollection Return();
    }
    //定義數據契約，數據契約是可以被序列化的并在C/S之間傳遞，並且只有成員可以被傳遞，方法不能被傳遞
    [DataContract]
    public class DataCollection
    {
        //定義數據成員
        [DataMember(Name = "姓名", EmitDefaultValue = true)]//默認的值EmitDefaultValue=true
        public string Name
        {
            get; set;
        }
        [DataMember(Name = "年齡")]
        public int Old
        {
            get; set;
        }
        //此項因為沒有定義成數據成員因此其在數據傳輸的時候不會被傳輸
        public string Address
        {
            set; get;
        }
    }

    [DataContract]
    public struct DataCollection2
    {

        [DataMember]
        public string Name
        {
            get; set;
        }

        [DataMember]
        public int Old
        {
            get; set;
        }

        public string Address
        {
            set;
            get;
        }
    }

    [DataContract]
    public class Err
    {
        [DataMember]
        public string Functionname
        {
            get; set;
        }
        [DataMember]
        public string ErrMessage
        {
            get; set;
        }

        [DataMember]
        public string Errm = "錯誤的很啊~~";

        public Err(string pFn,string pEm) 
        {
            Functionname = pFn;
            ErrMessage = pEm;
        }

    }
    //定義消息
    [MessageContract]
    public class Message
    {
        private string _name;
        private int _old;
        //聲明消息體
        [MessageBodyMember]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }
        //聲明消息頭
        [MessageHeader]
        public int Old
        {
            get { return _old; }
            set { _old = value; }
        }
    }
}
